/**
   @Author:
      Date: 
   Teacher:
       Lab:
      Misc:
  */

public class Simulation
{
    // Instance Variables: Encapsulated data for each simulation object
    private Environment theEnv;
    private EnvDisplay  theDisplay;

    public Simulation(Environment env, EnvDisplay display)
    {
        theEnv = env;
        theDisplay = display;

        // Display the initial state of the simulation.
        theDisplay.showEnv();
        Debug.println("-------- Initial Configuration --------");
        Debug.println(theEnv.toString());
        Debug.println("---------------------------------------");
    }

    public void step()
    {
        // Get all the fish in the environment and ask each
        // one to perform the actions it does in a timestep.
        Locatable[] theFishes = theEnv.allObjects();
        for ( int index = 0; index < theFishes.length; index++ )
        {
            ((Fish)theFishes[index]).act();
        }

        // Display the state of the simulation after this timestep.
        theDisplay.showEnv();
        Debug.println(theEnv.toString());
        Debug.println("-------- End of Timestep --------");
    }

}
