/**
   @Author:
      Date:
   Teacher:
       Lab:
      Misc:
  */

import java.awt.Color;
import java.util.ArrayList;
import java.util.Random;

public class SlowFish extends Fish
{
    private double probOfMoving;    // defines likelihood in each timestep

    public SlowFish(Environment env, Location loc)
    {
        // Construct and initialize the attributes inherited from Fish.
        super(env, loc, env.randomDirection(), Color.red);

        // Define the likelihood that a slow fish will move in any given
        // timestep.  For now this is the same value for all slow fish.
        probOfMoving = 1.0/5.0;       // 1 in 5 chance in each timestep
    }

    public SlowFish(Environment env, Location loc, Direction dir)
    {
        // Construct and initialize the attributes inherited from Fish.
        super(env, loc, dir, Color.red);

        // Define the likelihood that a slow fish will move in any given
        // timestep.  For now this is the same value for all slow fish.
        probOfMoving = 1.0/5.0;       // 1 in 5 chance in each timestep
    }
        
    public SlowFish(Environment env, Location loc, Direction dir, Color col)
    {
        // Construct and initialize the attributes inherited from Fish.
        super(env, loc, dir, col);

        // Define the likelihood that a slow fish will move in any given
        // timestep.  For now this is the same value for all slow fish.
        probOfMoving = 1.0/5.0;       // 1 in 5 chance in each timestep
    }

    protected void generateChild(Location loc)
    {
        // Create new fish, which adds itself to the environment.
        SlowFish child = new SlowFish(environment(), loc,
                                      environment().randomDirection(),
                                      color());
        Debug.println("  New SlowFish created: " + child.toString());
    }

    protected Location nextLocation()
    {
        // There's only a small chance that a slow fish will actually
        // move in any given timestep, defined by probOfMoving.
        Random randNumGen = RandNumGenerator.getInstance();
        if ( randNumGen.nextDouble() < probOfMoving )
            return super.nextLocation();
        else
        {
            Debug.println("SlowFish " + toString() + 
                          " not attempting to move.");
            return location();
        }
    }
}
